function FAR_plot_openbox (searchPath,mcPath,bkgPath,ff)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This macro is used to plot FAR curves from
% several FAR ASCII files generated by the FAR.m
%
% ID_ZL: ID dag which is currently processed (must be zerolag)
% ID_bkg: background dag ID compared to zerolag.
% ID_mc: MC dag ID
%
% M.-A. Bizouard (mabizoua@lal.in2p3.fr)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
verbose=0;
ppSveto=0;
mc=0;
bkg=0;


x1=load([ff '/FAR_all.mat']);
x2=load([ff '/FAR_DQ.mat']);
x3=load([ff '/FAR_SNRfrac.mat']);
x5=load([ff '/FAR_cut.mat']);
if exist( [ff '/FAR_ppS.mat'])
    x6=load([ff '/FAR_ppS.mat']);
    ppSveto=true;
end


if mcPath ~= 0
    mc_file=[mcPath '/figures/FAR_all.txt'];
    if exist(mc_file)
        display (['MC FAR is stored in: ' mcPath '/figures/' ...
                  'FAR_all.txt']);
        o=load(mc_file);
        x7.snr=o(:,1);
        x7.far=o(:,2);
        mc=1;

        % The MC at SNR=0 FAR is rescaled such it is equal to the
        % real data
        % FAR at SNR=0
        %factor=x3(1,2)/x5(1,2);
        %x5(:,2)=x5(:,2).*factor;
        if verbose==1
            display(['FAR at SNR=0:'])
            display(['Data:' num2str(x3(1,2))])
            display(['MC:' num2str(x5(1,2))])
            display(['(Data-MC) / Data:' num2str((x3(1,2)-x5(1,2))/ ...
                                                 x3(1,2)*100) '%'])
        end

    elseif exist([mcPath '/figures/FAR_all.mat'])
        x7=load([mcPath '/figures/FAR_all.mat']);
        
    else
        display(['Warning: No MC FAR file has been found in ' ...
                 mc_file]);
    end
end

close all

%%% PLOT
%%| General plot with all cut
figure()
hold on

xmax=max(x1.snr)*1.1;
xmax=100*ceil(xmax/100);
xmin = min(x1.snr)*0.9;
xlim([xmin xmax]);

ymin=10^(log10(min(x5.far(x5.far~=0)))*1.1);
ymax=10^(log10(max(x1.far(x5.far~=0)))*0.9);
ylim([ymin ymax]);
dx=x1.snr(2)-x2.snr(1);

stairs (x1.snr-dx/2,x1.far,'Color', 'k', 'LineWidth',2);
stairs (x2.snr-dx/2,x2.far,'Color', 'r', 'LineWidth',2);
stairs (x3.snr-dx/2,x3.far,'Color', 'm', 'LineWidth',2);
leg={'all cut', 'after DQ flags', 'after SNRfrac'};
if ppSveto
    stairs (x6.snr-dx/2,x6.far,'Color', 'y', 'LineWidth',2);
    leg=[leg 'ppS veto'];
end
stairs (x5.snr-dx/2,x5.far,'Color', 'g', 'LineWidth',2);
leg=[leg 'after all cut'];
if mc
    stairs (x7.snr-dx/2,x7.far,'Color', 'c' , 'LineWidth',2);;
    leg=[leg 'Gaussian noise'];
end

hold off
grid
box
set(gca(), 'YScale', 'log')
set(gca(), 'XScale', 'log')
set(gca(), 'XMinorTick','on')

legend(leg);
xlabel('SNR_{\Gamma}','fontsize',15);
ylabel('False alarm rate [Hz]','fontsize',15);
title('FAR for all triggers')
make_png(ff, 'FAR_all');

%%| DQFlags
figure()
ext=x1.far~=0;
xmax=max(x1.snr(ext))*1.1;
xmax=100*ceil(xmax/100);
xmin = min(min(x2.snr),12);

ymin=10^(log10(min(x2.far(x2.far~=0)))*1.1);
ymax=10^(log10(max(x1.far))*0.9);

snr=x2.snr(x2.snr<xmax&x2.snr>xmin);
far=min(max(x2.far(x2.snr<xmax&x2.snr>xmin),ymin),ymax);
asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 .9], ...
    'BarWidth', 1,'basevalue', ymin);
hold all

bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 .7], ...
    'BarWidth', 1,'basevalue', ymin);
dx=snr(2)-snr(1);
stairs (x2.snr-dx/2,x2.far, 'Color', [0 0 0]);
stairs (x1.snr-dx/2,x1.far, 'Color', [0 0 0]);
leg={'all triggers', 'after DG flags'};
if mc
    stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth',2);
    leg=[leg 'Gaussian noise'];
end

grid
box
set(gca(),'XLim',[xmin xmax]);
set(gca(),'YLim',[ymin ymax]);
set(gca(), 'YScale', 'log')
set(gca(), 'XScale', 'log')
set(gca(), 'XMinorTick','on')

legend(leg)
xlabel('SNR_{\Gamma}','fontsize',15);
ylabel('False alarm rate [Hz]','fontsize',15);
title('FAR after DQ flags')
hold off
make_png(ff, 'FAR_DQ');

%%% | SNRfrac
figure()

ext=find(x1.far>0);
xmax=x1.snr(ext(end))*1.1;
xmax=100*ceil(xmax/100);
xmin = max(min(x3.snr),12);

ymin=10^(log10(min(x3.far(x3.far~=0)))*1.1);
ymax=10^(log10(max(x3.far))*0.9);

snr=x3.snr(x3.snr<xmax&x3.snr>xmin);
far=min(max(x3.far(x3.snr<xmax&x3.snr>xmin),ymin),ymax);
asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 .9], ...
    'BarWidth', 1,'basevalue', ymin);
hold all
bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 .7], ...
    'BarWidth', 1,'basevalue', ymin);
dx=snr(2)-snr(1);
stairs (snr-dx/2,far, 'Color', [0 0 0]);
stairs (asnr-dx/2,afar, 'Color', [0 0 0]);
leg={'all triggers', 'after SNRfrac cut'};
if mc
    stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth',2);
    leg=[leg 'Gaussian noise'];
end
grid
box
set(gca(),'XLim',[xmin xmax]);
set(gca(),'YLim',[ymin ymax]);
set(gca(), 'YScale', 'log')
set(gca(), 'XScale', 'log')
set(gca(), 'XMinorTick','on')

legend(leg)
xlabel('SNR_{\Gamma}','fontsize',15);
ylabel('False alarm rate [Hz]','fontsize',15);
title('FAR after SNRfrac')
hold off
make_png(ff, 'FAR_SNRfrac');


%%| all cut
figure()
ext=find(x1.far>0);
xmax=x1.snr(ext(end))*1.1;
xmax=100*ceil(xmax/100);
xmin = min(min(x5.snr),12);

ymin=10^(log10(min(x5.far(x5.far~=0)))*1.1);
ymax=10^(log10(max(x1.far))*0.9);

snr=x5.snr(x5.snr<xmax&x5.snr>xmin);
far=min(max(x5.far(x5.snr<xmax&x5.snr>xmin),ymin),ymax);
asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 .9], ...
    'BarWidth', 1,'basevalue', ymin);
hold all
bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 .7], ...
    'BarWidth', 1,'basevalue', ymin);
dx=snr(2)-snr(1);
stairs (snr-dx/2,far, 'Color', [0 0 0]);
stairs (asnr-dx/2,afar, 'Color', [0 0 0]);
leg={'all triggers', 'after all cut'};
if mc
    stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth',2);
    leg=[leg 'Gaussian noise'];
end
grid
box
set(gca(),'XLim',[xmin xmax]);
set(gca(),'YLim',[ymin ymax]);
set(gca(), 'YScale', 'log')
set(gca(), 'XScale', 'log')
set(gca(), 'XMinorTick','on')

legend(leg)
xlabel('SNR_{\Gamma}','fontsize',15);
ylabel('False alarm rate [Hz]','fontsize',15);
title('FAR after all Cut')
hold off
make_png(ff, 'FAR_Cut');

if ppSveto
    %%% | ppS veto
    figure()
    ext=find(x1.far>0);
    xmax=x1.snr(ext(end))*1.1;
    xmax=100*ceil(xmax/100);
    xmin = min(min(x6.snr),12);

    ymin=10^(log10(min(x6.far(x6.far~=0)))*1.1);
    ymax=10^(log10(max(x1.far))*0.9);

    snr=x6.snr(x6.snr<xmax&x6.snr>xmin);
    far=min(max(x6.far(x6.snr<xmax&x6.snr>xmin),ymin),ymax);
    asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
    afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

    bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 ...
                        .9], 'BarWidth', 1,'basevalue', ymin);
    hold all
    bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 ...
                        .7], 'BarWidth', 1,'basevalue', ymin);
    dx=snr(2)-snr(1);
    stairs (snr-dx/2,far, 'Color', [0 0 0]);
    stairs (asnr-dx/2,afar, 'Color', [0 0 0]);
    leg={'all triggers', 'after ppS veto'};
    if mc
        stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth', ...
                2);
        leg=[leg 'Gaussian noise'];
    end

    grid
    box
    set(gca(),'XLim',[xmin xmax]);
    set(gca(),'YLim',[ymin ymax]);
    set(gca(), 'YScale', 'log')
    set(gca(), 'XMinorTick','on')
    set(gca(), 'XScale', 'log')

    legend(leg)
    xlabel('SNR_{\Gamma}','fontsize',15);
    ylabel('False alarm rate [Hz]','fontsize',15);
    title('FAR after ppS veto')
    hold off
    make_png(ff, 'FAR_ppS');
end


%%%---------------------------------------
%% ZEROS LAG PART
if bkgPath~=0
    ppSveto=false;
    
    bx1=load([ff '/FAR_all.mat']);
    bx2=load([ff '/FAR_DQ.mat']);
    bx3=load([ff '/FAR_SNRfrac.mat']);
    bx5=load([ff '/FAR_cut.mat']);
    if exist( [ff '/FAR_ppS.mat'])
        bx6=load([ff '/FAR_ppS.mat']);
        ppSveto=true;
    end
    
    x1=load([bkgPath '/figures/FAR_all.mat']);
    x2=load([bkgPath '/figures/FAR_DQ.mat']);
    x3=load([bkgPath '/figures/FAR_SNRfrac.mat']);
    x5=load([bkgPath '/figures/FAR_cut.mat']);
    if exist( [bkgPath '/figures/FAR_ppS.mat'])
        x6=load([bkgPath '/figures/FAR_ppS.mat']);
        ppSveto=true;
    end
    
    if mc==1
        try
            x7=load([mcPath '/figures/FAR_SNRfrac.mat']);
        catch
            o=load([mcPath '/figures/FAR_SNRfrac.txt']);
            x7.snr=o(:,1);
            x7.far=o(:,2);
        end
    end

    %%| DQFlags                                                                                               
    figure()
    ext=bx1.far~=0;
    xmax=max(bx1.snr(ext))*1.1;
    xmax=100*ceil(xmax/100);
    xmin = max(min(x2.snr),12);

    ymin=10^(log10(min(x2.far(x2.far~=0)))*1.1);
    ymax=10^(log10(max(x1.far))*0.9);

    snr=x2.snr(x2.snr<xmax&x2.snr>xmin);
    far=min(max(x2.far(x2.snr<xmax&x2.snr>xmin),ymin),ymax);
    asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
    afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

    bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 .9], ...
        'BarWidth', 1,'basevalue', ymin);
    hold all

    bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 .7], ...
        'BarWidth', 1,'basevalue', ymin);
    dx=snr(2)-snr(1);
    stairs (snr-dx/2,far, 'Color', [0 0 0]);
    stairs (asnr-dx/2,afar, 'Color', [0 0 0]);
    leg={'all triggers', 'after DG flags'};
    if mc
        stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth',2);
        leg=[leg 'Gaussian noise'];
    end

    dx=bx1.snr(2)-bx1.snr(1);
    plot(bx1.snr-dx/2,bx2.far,'Marker','^','LineStyle','none',...
         'MarkerFaceColor',[0.854901969432831 0.701960802078247 1],...
         'MarkerEdgeColor',[0.854901969432831 0.701960802078247 1]);
    grid
    box
    set(gca(),'XLim',[xmin xmax]);
    set(gca(),'YLim',[ymin ymax]);
    set(gca(), 'YScale', 'log')
    set(gca(), 'XScale', 'log')
    set(gca(), 'XMinorTick','on')

    legend([leg 'Zerolag after DQFlags'])
    xlabel('SNR_{\Gamma}','fontsize',15);
    ylabel('False alarm rate [Hz]','fontsize',15);
    title('FAR after DQ flags')
    hold off
    make_png(ff, 'FAR_DQ_ZL');

    %%% | SNRfrac
    figure()

    ext=find(bx1.far>0);
    xmax=bx1.snr(ext(end))*1.1;
    xmax=100*ceil(xmax/100);
    xmin = max(min(x1.snr),12);

    ymin=10^(log10(min(x3.far(x3.far~=0)))*1.1);
    ymax=10^(log10(max(x1.far))*0.9);

    snr=x3.snr(x3.snr<xmax&x3.snr>xmin);
    far=min(max(x3.far(x3.snr<xmax&x3.snr>xmin),ymin),ymax);
    asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
    afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

    bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 .9], ...
        'BarWidth', 1,'basevalue', ymin);
    hold all
    bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 .7], ...
        'BarWidth', 1,'basevalue', ymin);
    dx=snr(2)-snr(1);
    stairs (x3.snr-dx/2,x3.far, 'Color', [0 0 0]);
    stairs (x1.snr-dx/2,x1.far, 'Color', [0 0 0]);
    leg={'all triggers', 'after SNRfrac cut'};
    if mc
        stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth',2);
        leg=[leg 'Gaussian noise'];
    end

    dx=bx3.snr(2)-bx3.snr(1);
    plot(bx3.snr-dx/2,bx3.far,'Marker','^','LineStyle','none',...
         'MarkerFaceColor',[0.854901969432831 0.701960802078247 1],...
         'MarkerEdgeColor',[0.854901969432831 0.701960802078247 1]);

    grid
    box
    set(gca(),'XLim',[xmin xmax]);
    set(gca(),'YLim',[ymin ymax]);
    set(gca(), 'YScale', 'log')
    set(gca(), 'XScale', 'log')
    set(gca(), 'XMinorTick','on')

    legend([leg 'Zerolag after SNRfrac'])
    xlabel('SNR_{\Gamma}','fontsize',15);
    ylabel('False alarm rate [Hz]','fontsize',15);
    title('FAR after SNRfrac')
    hold off
    make_png(ff, 'FAR_SNRfrac_ZL');

    %%| all cut                
    figure()

    ext=find(bx1.far>0);
    xmax=bx1.snr(ext(end))*1.1;
    xmax=100*ceil(xmax/100);
    xmin = max(min(x1.snr),12);

    ymin=10^(log10(min(x5.far(x5.far~=0)))*1.1);
    ymax=10^(log10(max(x1.far))*0.9);

    snr=x5.snr(x5.snr<xmax&x5.snr>xmin);
    far=min(max(x5.far(x5.snr<xmax&x5.snr>xmin),ymin),ymax);
    asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
    afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

    bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 .9], ...
        'BarWidth', 1,'basevalue', ymin);
    hold all
    bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 .7], ...
        'BarWidth', 1,'basevalue', ymin);
    dx=snr(2)-snr(1);
    stairs (x5.snr-dx/2,x5.far, 'Color', [0 0 0]);
    stairs (x1.snr-dx/2,x1.far, 'Color', [0 0 0]);
    leg={'all triggers', 'after all cut'};
    if mc
        stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth',2);
        leg=[leg 'Gaussian noise'];
    end

    dx=bx5.snr(2)-bx5.snr(1);
    plot(bx5.snr-dx/2,bx5.far,'Marker','^','LineStyle','none',...
         'MarkerFaceColor',[0.854901969432831 0.701960802078247 1],...
         'MarkerEdgeColor',[0.854901969432831 0.701960802078247 1]);
    
    grid
    box
    set(gca(),'XLim',[xmin xmax]);
    set(gca(),'YLim',[ymin ymax]);
    set(gca(), 'YScale', 'log')
    set(gca(), 'XScale', 'log')
    set(gca(), 'XMinorTick','on')

    legend([leg 'Zerolag after all Cut'])
    xlabel('SNR_{\Gamma}','fontsize',15);
    ylabel('False alarm rate [Hz]','fontsize',15);
    title('FAR after all Cut')
    hold off
    make_png(ff, 'FAR_Cut_ZL');


    if ppSveto
        %%% | ppS veto
        figure()

        ext=find(bx1.far>0);
        xmax=bx1.snr(ext(end))*1.1;
        xmax=100*ceil(xmax/100);
        xmin = max(min(x6.snr),12);
        
        ymin=10^(log10(min(x6.far(x6.far~=0)))*1.1);
        ymax=10^(log10(max(x1.far))*0.9);
        
        snr=x6.snr(x6.snr<xmax&x6.snr>xmin);
        far=min(max(x6.far(x6.snr<xmax&x6.snr>xmin),ymin),ymax);
        asnr=x1.snr(x1.snr<xmax&x1.snr>xmin);
        afar=min(max(x1.far(x1.snr<xmax&x1.snr>xmin),ymin),ymax);

        bar(asnr,afar, 'FaceColor', [.9 .9 .9], 'EdgeColor', [.9 .9 ...
                            .9], 'BarWidth', 1,'basevalue', ymin);
        hold all
        bar(snr,far, 'FaceColor', [.7 .7 .7], 'EdgeColor', [.7 .7 ...
                            .7], 'BarWidth', 1,'basevalue', ymin);
        dx=x6.snr(2)-x6.snr(1);
        stairs (x6.snr-dx/2,x6.far, 'Color', [0 0 0]);
        stairs (x1.snr-dx/2,x1.far, 'Color', [0 0 0]);
        leg={'all triggers', 'after ppS veto'};
        if mc
            stairs (x7.snr-dx/2,x7.far, 'Color', [0 1 1],'LineWidth', ...
                    2);
            leg=[leg 'Gaussian noise'];
        end

        dx=bx6.snr(2)-bx6.snr(1);
        plot(bx6.snr-dx/2,bx6.far,'Marker','^','LineStyle','none',...
             'MarkerFaceColor',[0.854901969432831 0.701960802078247 1],...
             'MarkerEdgeColor',[0.854901969432831 0.701960802078247 ...
                            1]);

        grid
        box
        set(gca(),'XLim',[xmin xmax]);
        set(gca(),'YLim',[ymin ymax]);
        set(gca(), 'YScale', 'log')
        set(gca(), 'XMinorTick','on')
        set(gca(), 'XScale', 'log')

        legend([leg 'Zerolag after ppS veto'])
        xlabel('SNR_{\Gamma}','fontsize',15);
        ylabel('False alarm rate [Hz]','fontsize',15);
        title('FAR after ppS veto')
        hold off
        make_png(ff, 'FAR_ppS_ZL');
    end
end
